'From Squeak3.8gamma of ''24 November 2004'' [latest update: #6548] on 2 June 2005 at 1:09:51 pm'!
SmartSyntaxInterpreterPlugin subclass: #PrintJobPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMConstruction-Plugins'!

!PrintJobPlugin methodsFor: 'system primitives' stamp: 'JMM 2/7/2002 23:41'!
primitivePagePostProcessing: aSessionHandle
	| printJobData status |
	self var: #printJobData declareC: 'PrintingLogic *printJobData'.
	self primitive: 'primitivePagePostProcessing'
		parameters: #(Oop).
	printJobData _ self printingLogicValueOf: aSessionHandle.
	printJobData = nil ifTrue: [interpreterProxy success: false. ^-1].
	self cCode: 'status = ioPagePostProcessing(printJobData)'.
	^status asSmallIntegerObj.
! !

!PrintJobPlugin methodsFor: 'system primitives' stamp: 'JMM 2/7/2002 23:41'!
primitivePagePreProcessing: aSessionHandle
	| printJobData status |
	self var: #printJobData declareC: 'PrintingLogic *printJobData'.
	self primitive: 'primitivePagePreProcessing'
		parameters: #(Oop).

	printJobData _ self printingLogicValueOf: aSessionHandle.
	printJobData = nil ifTrue: [interpreterProxy success: false. ^-1].
	self cCode: 'status = ioPagePreProcessing(printJobData)'.
	^status asSmallIntegerObj.
! !

!PrintJobPlugin methodsFor: 'system primitives' stamp: 'JMM 2/20/2002 10:16'!
primitivePageSetForm: aSessionHandle bits: aBitMap  height: h width: w depth: d scaleH: sh scaleW: sw offsetH: oh offsetW: ow
	| printJobData status bitMap |
	self var: #printJobData declareC: 'PrintingLogic *printJobData'.
	self var: #bitMap declareC: 'char *bitMap'.
	self primitive: 'primitivePageSetForm'
		parameters: #(Oop Oop SmallInteger SmallInteger SmallInteger Float Float SmallInteger SmallInteger).
	printJobData _ self printingLogicValueOf: aSessionHandle.
	printJobData = nil ifTrue: [interpreterProxy success: false. ^-1].
	bitMap _ self cCoerce: (interpreterProxy firstIndexableField: aBitMap)
						to: 'char *'.
	self cCode: 'status = ioPageForm(printJobData,bitMap,h,w,d,sh,sw,oh,ow)'.
	^status asSmallIntegerObj.
! !

!PrintJobPlugin methodsFor: 'system primitives' stamp: 'JMM 2/8/2002 00:06'!
primitivePageSetPostscript: aSessionHandle postscript: aText
	| printJobData status sz |
	self var: #printJobData declareC: 'PrintingLogic *printJobData'.
	self primitive: 'primitivePageSetPostscript'
		parameters: #(Oop String).
	printJobData _ self printingLogicValueOf: aSessionHandle.
	printJobData = nil ifTrue: [interpreterProxy success: false. ^-1].
	sz _ interpreterProxy byteSizeOf: aText cPtrAsOop.
	self cCode: 'status = ioPagePostscript(printJobData,aText,sz)'.
	^status asSmallIntegerObj.
! !

!PrintJobPlugin methodsFor: 'system primitives' stamp: 'JMM 2/9/2002 01:12'!
primitivePrintCleanup: aSessionHandle
	| printJobData status printJobData2 |
	self var: #printJobData declareC: 'PrintingLogic *printJobData'.
	self var: #printJobData2 declareC: 'PrintingLogic **printJobData2'.
	self primitive: 'primitivePrintCleanup'
		parameters: #(Oop).
	printJobData _ self printingLogicValueOf: aSessionHandle.
	printJobData = nil ifTrue: [interpreterProxy success: false. ^-1].
	printJobData2 _ self cCoerce: (interpreterProxy firstIndexableField: aSessionHandle)
						to: 'PrintingLogic **'.
	self cCode: 'status = ioPrintCleanup(printJobData2)'.
	^status asSmallIntegerObj.
! !

!PrintJobPlugin methodsFor: 'system primitives' stamp: 'JMM 2/9/2002 12:07'!
primitivePrintGetFirstPageNumber: aSessionHandle
	| printJobData firstPage |

	self var: #printJobData declareC: 'PrintingLogic *printJobData'.
	self primitive: 'primitivePrintGetFirstPageNumber'
		parameters: #(Oop).
	printJobData _ self printingLogicValueOf: aSessionHandle.
	printJobData = nil ifTrue: [interpreterProxy success: false. ^0].
	self cCode: 'firstPage = ioPrintGetFirstPageNumber(printJobData)'.
	^firstPage asSmallIntegerObj.
! !

!PrintJobPlugin methodsFor: 'system primitives' stamp: 'JMM 2/9/2002 12:19'!
primitivePrintGetLastPageNumber: aSessionHandle
	| printJobData lastPage |

	self var: #printJobData declareC: 'PrintingLogic *printJobData'.
	self primitive: 'primitivePrintGetLastPageNumber'
		parameters: #(Oop).
	printJobData _ self printingLogicValueOf: aSessionHandle.
	printJobData = nil ifTrue: [interpreterProxy success: false. ^0].
	self cCode: 'lastPage = ioPrintGetLastPageNumber(printJobData)'.
	^lastPage asSmallIntegerObj.
! !

!PrintJobPlugin methodsFor: 'system primitives' stamp: 'JMM 2/7/2002 23:14'!
primitivePrintPostProcessing: aSessionHandle
	| printJobData status |
	self var: #printJobData declareC: 'PrintingLogic *printJobData'.
	self primitive: 'primitivePrintPostProcessing'
		parameters: #(Oop).
	printJobData _ self printingLogicValueOf: aSessionHandle.
	printJobData = nil ifTrue: [interpreterProxy success: false. ^-1].
	self cCode: 'status = ioPrintPostProcessing(printJobData)'.
	^status asSmallIntegerObj.
! !

!PrintJobPlugin methodsFor: 'system primitives' stamp: 'JMM 2/7/2002 23:15'!
primitivePrintPreProcessing: aSessionHandle pages: aNumber
	| printJobData status |
	self var: #printJobData declareC: 'PrintingLogic *printJobData'.
	self primitive: 'primitivePrintPreProcessing'
		parameters: #(Oop SmallInteger).

	printJobData _ self printingLogicValueOf: aSessionHandle.
	printJobData = nil ifTrue: [interpreterProxy success: false. ^-1].
	aNumber < 0 ifTrue: [interpreterProxy success: false. ^-1].
	self cCode: 'status = ioPrintPreProcessing(printJobData,aNumber)'.
	^status asSmallIntegerObj.
! !

!PrintJobPlugin methodsFor: 'system primitives' stamp: 'JMM 2/9/2002 13:32'!
primitivePrintSetup
	| printingLogicOop printJobData status |

	self var: #printJobData declareC: 'PrintingLogic **printJobData'.
	self primitive: 'primitivePrintSetup'.
	printingLogicOop _ interpreterProxy instantiateClass: interpreterProxy classByteArray
					indexableSize: 4.	
	printJobData _ self cCoerce: (interpreterProxy firstIndexableField: printingLogicOop)
						to: 'PrintingLogic **'.
	self cCode: 'status = ioPrintSetup(printJobData)'.
	status ~= 0 ifTrue: [interpreterProxy success: false. ^nil].
	^printingLogicOop.
! !

!PrintJobPlugin methodsFor: 'support' stamp: 'JMM 2/7/2002 21:58'!
initialiseModule
	self export: true.
	^self cCode: 'ioInitPrintJob()' inSmalltalk:[true]! !

!PrintJobPlugin methodsFor: 'support' stamp: 'JMM 2/7/2002 17:44'!
printingLogicValueOf: handle 
	"Return a pointer to the first byte of of the PrintingLogic record within the  
	given Smalltalk object, or nil if handle is not a PrintingLogic record."
	| index |

	self returnTypeC: 'PrintingLogic *'.
	self var: #index declareC: 'PrintingLogic ** index'.
	interpreterProxy success: ((interpreterProxy isBytes: handle)
			and: [(interpreterProxy byteSizeOf: handle)
					= 4]).
	interpreterProxy failed
		ifTrue: [^ nil]
		ifFalse: 
			[index _ self cCoerce: (interpreterProxy firstIndexableField: handle) 
				to: 'PrintingLogic **'.
			index = 0 ifTrue: [^nil]. 
			^ self cCode: '*index']! !

!PrintJobPlugin methodsFor: 'support' stamp: 'JMM 2/7/2002 21:59'!
shutdownModule
	self export: true.
	^self cCode: 'ioShutdownPrintJob()' inSmalltalk:[true]! !


!PrintJobPlugin class methodsFor: 'translation' stamp: 'JMM 8/7/2002 17:59'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^true! !

!PrintJobPlugin class methodsFor: 'translation' stamp: 'JMM 8/7/2002 18:00'!
requiresPlatformFiles
	"default is ok for most, any plugin needing platform specific files must say so"
	^true! !

