| manifest load |

"Update Trunk image"
[MCMcmUpdater default doUpdate: false] on: Warning do: [:ex | ex resume: true].

"Disable underscore as assignment, allowing underscores in method names."
Scanner allowUnderscoreAsAssignment: false.

manifest := #(	
	squeak	'FFI'
		0	('FFI-Pools' 'FFI-Kernel')
	squeak	'FFI' "Split up because of how extension methods are loaded"
		1	('FFI-Libraries' 'FFI-Tools' 'FFI-Callbacks'
			'FFI-Tests' 'FFI-PoolsTests' 'FFI-CallbacksTests')
	squeak	'VMMaker'
		6	('CogPools-ISAs' 'BytecodeSets.spur' 'VMMaker.oscog' 'VMMakerUI'
			'Cog' 'CogTools' 'ImageFormat' 'FileAttributesPlugin.oscog')
	squeak	'VMMaker'
		3	('MethodMassage' 'MethodMassageCompatibility')
	squeaksource		'AioPlugin'
		7	('VMConstruction-Plugins-AioPlugin.oscog')
	squeaksource		'Alien'			
		0	('Alien-Core' 'Alien-Tests-Core' 'Alien-Win32')
	squeaksource3	'FreeTypePlus' "more recent than on squeaksource"
		5	('FreeTypeConstants' "'FreeType'")
	squeaksource		'FreetypePlugin'
		8	('Freetype-Plugin')
	squeaksource		'OSProcess'
		4	('OSProcess')
	squeaksource		'OSProcessPlugin'
		9	('VMConstruction-Plugins-OSProcessPlugin.oscog')
	squeaksource		'rb'
		5	('AST-Core' 'AST-Semantic' 'AST-Tests-Core' 'AST-Tests-Semantic'
			'Refactoring-Changes' 'Refactoring-Core' 'Refactoring-Environment'
			'Refactoring-Tests-Changes' 'Refactoring-Tests-Core'
			'Refactoring-Tests-Environment' 'Refactoring-Squeak-Platform'
			'Refactoring-Critics' 'Refactoring-Spelling')
	squeaksource		'Speech' "This for the Klatt speech synthesiser, but seems to be AWOL"
		2	('SharedPool-Speech' )
	squeaksource		'XDCP'
		9	('VMConstruction-Plugins-XDisplayControlPlugin.oscog' )
	squeaksource		'Balloon3D'
		9	('Balloon3D-Constants' 'Balloon3D-Plugins'  )
	squeaksource		'Cryptography'
		9	('CryptographyPlugins'  )
	squeak	'VMMaker'
		9	('AndreasProfiler')
	squeaksource		'Printf'
		5	('Printf')
	squeaksource		'VectorEnginePlugin'
		9	('VectorEnginePlugin')
	squeaksource		'dbus'
		9	('DBus-Plugin')
	squeaksource		'Rome'
		9	('Rome-Base' 'Rome-PluginCanvas' 'Rome-Plugin')
	squeaksource		'GStreamer'
		9	('GStreamer-Plugins')
	).

load := Array streamContents: [:s |
	manifest groupsDo: [:installerSymbol :project :order :packages |
		| installer |
		installer := Installer perform: installerSymbol.
		installer project: project.
		installer packages addAll: packages.
		s nextPut: order -> installer]].
load := (load sorted: [:a :b | a key <= b key]) collect: [:ea | ea value].
load do: [:installer | installer installQuietly].

self currentWorld findATranscript: nil.

Project uiManager
	edit: (FileDirectory default fileNamed: 'Workspace.text') contentsOfEntireFile
	label: 'Overview'
	shouldStyle: false.

#('VM Simulation' 'Source Generation' 'Slang Test' 'In-image Compilation')
	reverseDo: [:nickname| | label |
	label := nickname, ' Workspace'.
	Project uiManager
		edit: (FileDirectory default fileNamed: label, '.text') contentsOfEntireFile
		label: label
		shouldStyle: true].

Utilities appendToCommonRequests: '-\VMMaker generateConfiguration\VMMaker generateAllConfigurationsUnderVersionControl\VMClass openCogMultiWindowBrowser\VMClass openObjectMemoriesInterpretersBrowser\VMClass openSpurMultiWindowBrowser' withCRs.

CodeHolder useMultiWindowBrowsers: true.

#('Cog' 'CogTools' 'VMMaker') do:
	[:pkg|
	(PackageInfo named: pkg) classes do:
		[:c|
		c organization sortCategories.
		c class organization sortCategories]].

(Smalltalk classNamed: #StackInterpreter) withAllSubclasses do:
	[:sic| sic reorganizeAsISeeFit].

Smalltalk snapshot: true andQuit: true
