| manifest load |
Scanner prefAllowUnderscoreSelectors: true.

manifest := #(	('http://source.squeak.org/FFI'					1	('FFI-Pools' 'FFI-Kernel'))
				('http://source.squeak.org/VMMaker'		6	('Balloon-Engine-Pools' 'VMMaker.oscog' 'Cog' 'CogTools' 'ImageFormat' 'CMakeVMMaker' 'CMakeVMMakerSqueak')) 
				('http://ss3.gemstone.com/ss/MethodMassage'		3	('MethodMassage' 'MethodMassageCompatibility'))
				('http://www.squeaksource.com/AioPlugin'		7	('VMConstruction-Plugins-AioPlugin'))
				('http://www.squeaksource.com/Alien'			0	('Alien'))
				"('http://www.squeaksource.com/FreeTypePlus'	5	('FreeType')) can't load this.  it is toxic to Squeak 4.5"
				('http://ss3.gemstone.com/ss/FreeTypePlus'	5	('FreeTypeConstants' 'FreeType' 'FreeTypeTests')) 
				('http://www.squeaksource.com/FreetypePlugin'	8	('Freetype-Plugin'))
				('http://www.squeaksource.com/OSProcess'		4	('OSProcess'))
				('http://www.squeaksource.com/OSProcessPlugin'	9	('VMConstruction-Plugins-OSProcessPlugin.oscog'))
				('http://www.squeaksource.com/rb'				5	('AST-Core' 'AST-Semantic' 'AST-Tests-Core' 'AST-Tests-Semantic' 'Refactoring-Changes' 'Refactoring-Core' 'Refactoring-Environment' 'Refactoring-Tests-Changes' 'Refactoring-Tests-Core' 'Refactoring-Tests-Environment'))
				('http://www.squeaksource.com/Speech'			2	('SharedPool-Speech' ))).

load := (manifest collect:
				[:tuple|
				[:path :order :packages| | repository |
				repository := MCHttpRepository
								location: path
								user: 'squeak'
								password: 'squeak'.
				MCRepositoryGroup default addRepository: repository.
				{repository. order. packages}] valueWithArguments: tuple])
			sort: [:a :b| a second <= b second].

#(	'FT2Constants.st'
	'Object-performwithwithwithwithwith.st'
	'CompiledMethod-usesAlternateBytecodeSet.st'
	'FileDirectory-on-methods.st'
	) do:
	[:fileName| (FileDirectory default fileNamed: fileName) fileIn].

World findATranscript: nil.

load do:
	[:tuple|
	 [:repository :order :packages|
	  packages do:
		[:package| | latestVersion |
		latestVersion := (repository versionNamesForPackageNamed: package) first.
		[| version |
		version := ((MCCacheRepository default includesVersionNamed: latestVersion)
					ifTrue: [MCCacheRepository default]
					ifFalse: [repository]) versionNamed: latestVersion.
		 version load.
		 version workingCopy repositoryGroup addRepository: repository]
			on: Warning
			do: [:ex|
				(ex messageText beginsWith: 'This package depends on the following classes') ifFalse:
					[ex pass].
				ex resume]]]
		valueWithArguments: tuple].


VMMakerTool openInWorld.
#( 'Workspace' 'VM Simulation Workspace' 'Slang Test Workspace' 'CMakeVMMakerSqueak') reverse do:
	[:textFileName|
	(StringHolder new contents: (FileDirectory default fileNamed: textFileName, '.text') contentsOfEntireFile)
		openLabel: textFileName].

(Utilities classPool at: #CommonRequestStrings) ifNotNil:
	[:crs|
	crs contents: crs contents, '\-\VMMaker generateConfiguration\VMMaker generateAllConfigurationsUnderVersionControl\VMClass openCogMultiWindowBrowser\VMClass openObjectMemoriesInterpretersBrowser' withCRs].

CodeHolder useMultiWindowBrowsers: true.

Smalltalk snapshot: true andQuit: true
